#include <descriptor/descriptor.h>

int main(void) {

	ITEM	glass,metallo,gomma,cromatura,piastrella,pelle,plastica_casco, plastica_casco2, lucido;
	ITEM	acciaio,vernice,alluminio,alluminio2,black,plastica_stop, lucido_foto, cromatura2;
	ITEM	vetrino, scatola_fanale, fanale_cromatura, fanale, muro, plastica_nera;
	ITEM	cerchione, copertone, ruota, ruota2, battistrada, spalla1, spalla2;
	ITEM	raggio1, raggio2, raggio3, raggio4, raggio5, mozzo, mozzo2, mozzo3;
	ITEM	garage, floor, soffitto, parete1, parete2, parete3, parete4;
	ITEM	forcella_sx, forcella_dx, forcella_alta, forcella_bassa, forcella,
			unisci_forcelle1, unisci_forcelle2;
	ITEM	manubrio, manubrio_dx, manubrio_sx, manopola_dx, manopola_sx, manopole, manubrio2;
	ITEM	strumentazione, contagiri, tachimetro, cruscotto;
	ITEM	serbatoio, serbatoio_sx, serbatoio_dx, sella, corpo, telaio, telaio1, telaio2;
	ITEM	meccanica, blocco_motore, carburatori, copri_albero, copri_albero_trasm, scarico;
	ITEM	forcella_post_sx, forcella_post_dx, collettore_scarico, collettore_centrale, terminale_dx, terminale_sx;
	ITEM	sottosella_dx, sottosella_sx, stop, spoiler_dx, spoiler_sx, retro_testa, sospensione;
	ITEM	moto, casco, visiera, visiera_sx, visiera_dx, guscio, piedistallo, foto;
	ITEM	tavolo, tavolo_top, gamba1, gamba2, gamba3, gamba4;
	ITEM	scene;

	set_background(0.676,0.861,0.953,TRUE);
	set_ambient_light(1,1,1,1);
	create_point_light(3,-1.544,4.154,1,1,1,1,16, "light1");
//	create_point_light(0.444,-7.744,1.098,1,1,1,1,16, "light2");
//	create_point_light(0.420,0,0.123,1,1,1,6,8,"luce_fanale");
//	create_point_light(-2.908,0,0.116,1,0,0,3,5, "luce_stop");

	/*** ATTRIBUTE glass ***/
	glass = create_attribute("glass");
	set_color(glass,0.88,0.96,1,0.5,0.5);
	set_reflectivity(glass,0.24,2);
	set_transparency(glass,0.87,0.68,1,1.2);

	/*** ATTRIBUTE cromatura ***/
	cromatura = create_attribute("cromatura");
	set_color(cromatura,0.78,0.78,0.78,0.08,0.853);
	set_reflectivity(cromatura,1,64);

	/*** ATTRIBUTE cromatura2 ***/
	cromatura2 = create_attribute("cromatura2");
	set_color(cromatura2,0.6,0.6,0.6,0.08,0.853);
	set_reflectivity(cromatura2,0.4,4);

	/*** ATTRIBUTE pelle ***/
	pelle = create_attribute("pelle");
	set_color(pelle,0.2,0.2,0.2,0.4,0.9);
	set_reflectivity(pelle,0.02,4);

	/*** ATTRIBUTE metallo ***/
	metallo = create_attribute("metallo");
	set_color(metallo,0.78,0.78,0.78,0.41,0.9);
	set_reflectivity(metallo,0.02,10);

	/*** ATTRIBUTE acciaio ***/
	acciaio = create_attribute("acciaio");
	set_color(acciaio,0.78,0.78,0.78,0.4,0.9);
	set_reflectivity(acciaio,0.1,10);

	/*** ATTRIBUTE alluminio ***/
	alluminio = create_attribute("alluminio");
	set_color(alluminio,0.5,0.5,0.5,0.4,0.9);

	/*** ATTRIBUTE alluminio2 ***/
	alluminio2 = create_attribute("alluminio2");
	set_color(alluminio2,0.7,0.7,0.7,0.4,0.9);
	set_reflectivity(alluminio2,0.1,4);

	/*** ATTRIBUTE gomma ***/
	gomma = create_attribute("gomma");
	set_color(gomma,0.2,0.2,0.2,0.7,1);

	/*** ATTRIBUTE plastica_nera ***/
	plastica_nera = create_attribute("plastica_nera");
	set_color(plastica_nera,0.3,0.3,0.3,0.8,1);

	/*** ATTRIBUTE plastica_casco ***/
	plastica_casco = create_attribute("plastica_casco");
	set_color(plastica_casco,0.12,0.12,0.12,0.54,0.72);
	set_reflectivity(plastica_casco,0.2,4);

	/*** ATTRIBUTE plastica_casco2 ***/
	plastica_casco2 = create_attribute("plastica_casco2");
	set_color(plastica_casco2,0,0,0,0.2,0.72);
	set_reflectivity(plastica_casco2,0.2,4);

	/*** ATTRIBUTE piastrella ***/
	piastrella = create_attribute("piastrella");
	set_color(piastrella,0.702,0.153,0,0.8,1);
	set_reflectivity(piastrella,0.01,16);
	
	/*** ATTRIBUTE muro ***/
	muro = create_attribute("muro");
	set_color(muro,1,1,1,0.7,0.9);
	
	/*** ATTRIBUTE vernice ***/
	vernice = create_attribute("vernice");
	set_color(vernice,1,0,0,0.2,1);
	set_reflectivity(vernice,0.1,4);
	
	/*** ATTRIBUTE black ***/
	black = create_attribute("black");
	set_color(black,0,0,0,0.2,1);
	set_reflectivity(black,0.1,4);
	
	/*** ATTRIBUTE plastica_stop ***/
	plastica_stop = create_attribute("plastica_stop");
	set_color(plastica_stop,1,0,0,0.7,1);
	set_reflectivity(plastica_stop,0.1,4);
	set_transparency(plastica_stop,0.52,0.38,1,1.2);
	//set_transparency(plastica_stop,0.87,0.68,1,1.2);
	
	/*** ATTRIBUTE lucido ***/
	lucido = create_attribute("lucido");
	set_color(lucido,1,1,1,0.5,0.8);
	set_reflectivity(lucido,0.333,4);
	
	/*** ATTRIBUTE lucido_foto ***/
	lucido_foto = create_attribute("lucido_foto");
	set_color(lucido_foto,1,1,1,0.2,1);
	set_reflectivity(lucido_foto,0.1,4);
	
	/*** FANALE ***/
	vetrino = read_nurbs("vetrino.db");
	set_attribute(vetrino,glass);

	scatola_fanale = read_nurbs("scatola_fanale.db");
	set_attribute(scatola_fanale,gomma);
	fanale_cromatura = read_nurbs("fanale_cromatura.db");
	set_attribute(fanale_cromatura,cromatura);
	
	fanale = create_list(scatola_fanale, "Fanale");
	fanale = insert_in_list(fanale, fanale_cromatura);
	fanale = insert_in_list(fanale, vetrino);

	set_y_rotate(fanale,90,1);
	set_scale(fanale, 0.3, 0.45, 0.45);
	set_translate(fanale,0.480,0,0.123);

	/*** STRUMENTAZIONE ***/

	strumentazione = read_nurbs("strumentazione.db");
	cruscotto = create_list(strumentazione, "Cruscotto");
	tachimetro = read_nurbs("contagiri.db");
	contagiri = read_nurbs("contagiri.db");
	set_translate(contagiri, 1.1,0,0);
	cruscotto = insert_in_list(cruscotto, tachimetro);
	cruscotto = insert_in_list(cruscotto, contagiri);
	set_attribute(cruscotto,plastica_nera);
	set_z_rotate(cruscotto, -90,1);
	set_scale(cruscotto, 0.2,0.2,0.2);
	set_y_rotate(cruscotto, 30,1);
	set_translate(cruscotto,0.17,0,0.45);

	/*** RUOTA ***/

	battistrada = read_nurbs("battistrada.db");
	set_attribute(battistrada,gomma);
	spalla1 = read_nurbs("spalla1.db");
	spalla2 = read_nurbs("spalla2.db");
	copertone = create_list(spalla1, "Copertone");
	copertone = insert_in_list(copertone, battistrada);
	copertone = insert_in_list(copertone, spalla2);
	set_attribute(copertone,gomma);
	set_bump_texture(battistrada,gomma,"texture/bump_battistrada.hr",0.07,1,0.8,1,1,1.0,1.0);

	cerchione = read_nurbs("cerchio_part.db");
	set_attribute(cerchione,metallo);
	mozzo = read_nurbs("mozzo.db");
	set_y_rotate(mozzo,90,1);
	set_attribute(mozzo,metallo);
/*	mozzo2 = read_nurbs("mozzo2.db");
	set_y_rotate(mozzo2,90,1);
	set_attribute(mozzo2,acciaio); */
	raggio1 = read_nurbs("raggio.db");
	set_attribute(raggio1,metallo);
	set_x_rotate(raggio1,90,1);
	set_y_rotate(raggio1,90,1);
	raggio2 = read_nurbs("raggio.db");
	set_attribute(raggio2,metallo);
	set_x_rotate(raggio2,90,1);
	set_y_rotate(raggio2,90,1);
	set_z_rotate(raggio2,72,1);
	raggio3 = read_nurbs("raggio.db");
	set_attribute(raggio3,metallo);
	set_x_rotate(raggio3,90,1);
	set_y_rotate(raggio3,90,1);
	set_z_rotate(raggio3,144,1);
	raggio4 = read_nurbs("raggio.db");
	set_attribute(raggio4,metallo);
	set_x_rotate(raggio4,90,1);
	set_y_rotate(raggio4,90,1);
	set_z_rotate(raggio4,216,1);
	raggio5 = read_nurbs("raggio.db");
	set_attribute(raggio5,metallo);
	set_x_rotate(raggio5,90,1);
	set_y_rotate(raggio5,90,1);
	set_z_rotate(raggio5,288,1);
	
	ruota = create_list(copertone,"Ruota");
	ruota = insert_in_list(ruota, cerchione);
	ruota = insert_in_list(ruota, raggio1);
	ruota = insert_in_list(ruota, raggio2);
	ruota = insert_in_list(ruota, raggio3);
	ruota = insert_in_list(ruota, raggio4);
	ruota = insert_in_list(ruota, raggio5);
	ruota = insert_in_list(ruota, mozzo);
//	ruota = insert_in_list(ruota, mozzo2);

	set_scale(ruota,0.91,0.91,0.7);
	set_x_rotate(ruota,90,1);
	set_translate(ruota,0.65,0,-1.1);

	mozzo2 = read_nurbs("mozzo2.db");
	set_y_rotate(mozzo2,90,1);
	set_attribute(mozzo2,acciaio);
	set_scale(mozzo2,0.91,0.91,0.7);
	set_x_rotate(mozzo2,90,1);
	set_translate(mozzo2,0.65,0,-1.1);
	
	/*** RUOTA POSTERIORE ***/ 
	ruota2 = create_copy(ruota, "Ruota_posteriore");
	set_scale(ruota2,1.1,1.3,1.1);
	set_translate(ruota2,-3.28325,0,0.2);
	mozzo3 = read_nurbs("mozzo2.db");
	set_y_rotate(mozzo3,90,1);
	set_attribute(mozzo3,acciaio);
	set_scale(mozzo3,0.91,0.91,0.7);
	set_x_rotate(mozzo3,90,1);
	set_translate(mozzo3,0.65,0,-1.1);
	set_scale(mozzo3,1.1,1,1.1);
	set_translate(mozzo3,-3.28325,0,0.2);
	
	/*** FORCELLA ***/
	forcella_sx = read_obj("forcella.obj","Forcella_sx");
	forcella_dx = read_obj("forcella.obj","Forcella_dx");
	set_translate(forcella_dx, 0.38, 0, 0);

	unisci_forcelle1 = read_nurbs("unisci_forcelle_alto.db");
	unisci_forcelle2 = read_nurbs("unisci_forcelle_basso.db");
	forcella = create_list(forcella_sx,"Forcella");
	forcella = insert_in_list(forcella, forcella_dx);
	forcella = insert_in_list(forcella, unisci_forcelle1);
	forcella = insert_in_list(forcella, unisci_forcelle2);
	set_attribute(forcella, acciaio);


	/*** MANUBRIO ***/
	manubrio = read_nurbs("manubrio.db");
	manopola_sx = read_nurbs("manopola2_sx.db");
	manopola_dx = read_nurbs("manopola2_dx.db");
	manopole = create_list(manopola_sx, "Manopole");
	manopole = insert_in_list(manopole, manopola_dx);
	manubrio2 = create_list(manubrio,"Manubrio");
	manubrio2 = insert_in_list(manubrio2, manopole);
	set_z_rotate(manubrio2,-90,1);
	set_translate(manubrio2,0.3,0,-0.985);
	set_scale(manubrio2,0.77,0.77,0.77);
	set_attribute(manubrio, cromatura);
	set_attribute(manopole, gomma);
	set_translate(manubrio2,-0.166,0,0.226);

	/*** SERBATOIO ***/
/*	serbatoio = read_nurbs("serbatoio2.db");
	set_scale(serbatoio,3,3,3);
	set_x_rotate(serbatoio,180,1);
	set_projection_texture(serbatoio,vernice,"texture/ducati.hr",0,0,0.4,1);
	set_x_rotate(serbatoio,180,1);
	set_scale(serbatoio,0.3333,0.3333,0.3333); */
	
	serbatoio_sx = read_nurbs("serbatoio_sx.db");
	set_scale(serbatoio_sx,3,3,3);
	set_x_rotate(serbatoio_sx,180,1);
	set_projection_texture(serbatoio_sx,vernice,"texture/ducati2.hr",0,0,0.2,1);
	set_x_rotate(serbatoio_sx,180,1);
	set_scale(serbatoio_sx,0.3333,0.3333,0.3333);
	
	serbatoio_dx = read_nurbs("serbatoio_dx.db");
	set_scale(serbatoio_dx,3,3,3);
	set_x_rotate(serbatoio_dx,180,1);
	set_projection_texture(serbatoio_dx,vernice,"texture/ducati.hr",0,0,0.2,1);
	set_x_rotate(serbatoio_dx,180,1);
	set_scale(serbatoio_dx,0.3333,0.3333,0.3333);
	
	/*** SELLA ***/
	sella = read_nurbs("sella.db");
	set_attribute(sella, pelle);
	sottosella_dx = read_nurbs("sottosella_dx.db");
	sottosella_sx = read_nurbs("sottosella_sx.db");
	set_attribute(sottosella_dx, black);
	set_attribute(sottosella_sx, black);
	stop = read_nurbs("stop.db");
	set_translate(stop,0,-0.05,0);
	set_attribute(stop, plastica_stop);
	spoiler_dx = read_nurbs("spoiler_dx.db");
	spoiler_sx = read_nurbs("spoiler_sx.db");
	set_attribute(spoiler_dx, black);
	set_attribute(spoiler_sx, black);

	/*** TELAIO ***/
/*	telaio1 = read_nurbs("telaio1.db");
	telaio2 = read_nurbs("telaio2.db");
	telaio = create_list(telaio2,"Telaio");
	telaio = insert_in_list(telaio, telaio1); */
	telaio = read_obj("telaio.obj","Telaio");
	set_attribute(telaio, vernice);

	/*** MECCANICA ***/
	blocco_motore = read_nurbs("blocco_motore.db");
	carburatori = read_nurbs("carburatori.db");
	copri_albero = read_nurbs("copri_albero.db");
	copri_albero_trasm = read_nurbs("copri_albero_trasm.db");
	forcella_post_sx = read_nurbs("forcella_post.db");
	forcella_post_dx = read_nurbs("forcella_post.db");
	set_translate(forcella_post_dx, 0.354,0.2,0.05);
	set_translate(forcella_post_sx, 0,0.2,0.05);
	collettore_scarico = read_nurbs("collettore_scarico.db");
	collettore_centrale = read_nurbs("collettore_centrale.db");
	terminale_dx = read_nurbs("terminale_dx.db");
	terminale_sx = read_nurbs("terminale_sx.db");
	retro_testa = read_nurbs("retro_testa.db");
	sospensione = read_nurbs("sospensione.db");
	meccanica = create_list(blocco_motore,"Meccanica");
	meccanica = insert_in_list(meccanica,carburatori);
	meccanica = insert_in_list(meccanica,copri_albero);
	meccanica = insert_in_list(meccanica,copri_albero_trasm);
	meccanica = insert_in_list(meccanica,forcella_post_sx);
	meccanica = insert_in_list(meccanica,forcella_post_dx);
	meccanica = insert_in_list(meccanica,retro_testa);
	meccanica = insert_in_list(meccanica,sospensione);
	set_attribute(meccanica, alluminio);
	set_attribute(carburatori, gomma);
	set_attribute(retro_testa, gomma);
	set_attribute(sospensione, gomma);


	corpo = create_list(serbatoio_dx,"Corpo");
	corpo = insert_in_list(corpo,forcella);
	corpo = insert_in_list(corpo,serbatoio_sx);
	corpo = insert_in_list(corpo,sella);
	corpo = insert_in_list(corpo,sottosella_dx);
	corpo = insert_in_list(corpo,sottosella_sx);
	corpo = insert_in_list(corpo,spoiler_dx);
	corpo = insert_in_list(corpo,spoiler_sx);
	corpo = insert_in_list(corpo,stop);
	corpo = insert_in_list(corpo,telaio);
	corpo = insert_in_list(corpo,meccanica);

	set_scale(corpo, 1.2, 1, 1);

	scarico = create_list(collettore_scarico,"Scarico");
	scarico = insert_in_list(scarico,collettore_centrale);
	scarico = insert_in_list(scarico,terminale_dx);
	scarico = insert_in_list(scarico,terminale_sx);
	set_attribute(scarico, alluminio2);
	corpo = insert_in_list(corpo,scarico);

	set_z_rotate(corpo,-90,1);
//	set_scale(corpo, 1.3, 1.3, 1.3);
	set_translate(corpo,-0.5,0,0);


	/*** STANZA ***/
	floor = read_nurbs("table.db");
	set_scale(floor,2,2,2);
	set_z_rotate(floor,45,1);
	set_projection_texture(floor,muro,"texture/pavimento.hr",2,1,0.4,0.9);
	set_z_rotate(floor,-45,1);
	set_scale(floor,0.5,0.5,0.5);
	
	soffitto = read_nurbs("table.db");
	set_attribute(soffitto, muro);
	set_translate(soffitto,0,0,6.4);

	parete1 = read_nurbs("table.db");
	set_scale(parete1,1,0.4,1);
	set_x_rotate(parete1,90,1);
	set_scale(parete1,1,1,0.16);
	set_translate(parete1,0,0,1.51);
//	set_projection_texture(parete1,muro,"texture/muro.hr",1,1,0.4,0.9);
	set_translate(parete1,0,0,-1.51);
	set_scale(parete1,1,1,6.25);
	set_translate(parete1,0,-8,3.2);

	parete2 = read_nurbs("table.db");
	set_scale(parete2,1,0.4,1);
	set_x_rotate(parete2,90,1);
	set_scale(parete2,1,1,0.16);
	set_translate(parete2,0,0,1.51);
//	set_projection_texture(parete2,muro,"texture/muro.hr",1,1,0.4,0.9);
	set_translate(parete2,0,0,-1.51);
	set_scale(parete2,1,1,6.25);
	set_z_rotate(parete2,90,1);
	set_translate(parete2,-8,0,3.2);

	parete3 = read_nurbs("table.db");
	set_scale(parete3,1,0.4,1);
	set_x_rotate(parete3,90,1);
	set_scale(parete3,1,1,0.16);
	set_translate(parete3,0,0,1.51);
//	set_projection_texture(parete3,muro,"texture/muro.hr",1,1,0.4,0.9);
	set_translate(parete3,0,0,-1.51);
	set_scale(parete3,1,1,6.25);
	set_translate(parete3,0,8,3.2);

	parete4 = read_nurbs("table.db");
	set_scale(parete4,1,0.4,1);
	set_x_rotate(parete4,90,1);
	set_scale(parete4,1,1,0.16);
	set_translate(parete4,0,0,1.51);
//	set_projection_texture(parete4,muro,"texture/muro.hr",1,1,0.4,0.9);
	set_translate(parete4,0,0,-1.51);
	set_scale(parete4,1,1,6.25);
	set_z_rotate(parete4,90,1);
	set_translate(parete4,8,0,3.2);

	set_attribute(parete1, muro);
	set_attribute(parete2, muro);
	set_attribute(parete3, muro);
	set_attribute(parete4, muro);

	garage = create_list(floor,"garage");
	garage = insert_in_list(garage, soffitto);
	garage = insert_in_list(garage, parete1);
	garage = insert_in_list(garage, parete2);
	garage = insert_in_list(garage, parete3);
	garage = insert_in_list(garage, parete4);

	set_translate(garage,0,0,-1.6);

	/*** PIEDISTALLO ***/
	piedistallo = read_nurbs("piedistallo.db");
	set_attribute(piedistallo, plastica_casco2);
	
	moto = create_list(corpo, "Monster");
	moto = insert_in_list(moto,fanale);
	moto = insert_in_list(moto,ruota);
	moto = insert_in_list(moto,ruota2);
	moto = insert_in_list(moto,mozzo2);
	moto = insert_in_list(moto,mozzo3);
	moto = insert_in_list(moto,manubrio2);
	moto = insert_in_list(moto,cruscotto);
	moto = insert_in_list(moto,piedistallo);

	set_scale(moto,0.25,0.25,0.25);
	set_translate(moto,0,0.5,0.52);
	set_z_rotate(moto,90,1);

	/*** TAVOLO ***/
	tavolo_top = read_nurbs("tavolo_top.db");
	set_x_rotate(tavolo_top,90,1);
	set_projection_texture(tavolo_top, lucido, "texture/marmo.hr",1,1,0.4,0.9);
	set_x_rotate(tavolo_top,-90,1);
	gamba1 = read_nurbs("gamba1.db");
	set_attribute(gamba1,cromatura2);
	gamba2 = read_nurbs("gamba2.db");
	set_attribute(gamba2,cromatura2);
	gamba3 = read_nurbs("gamba3.db");
	set_attribute(gamba3,cromatura2);
	gamba4 = read_nurbs("gamba4.db");
	set_attribute(gamba4,cromatura2);
	tavolo = create_list(tavolo_top, "Tavolo");
	tavolo = insert_in_list(tavolo, gamba1);
	tavolo = insert_in_list(tavolo, gamba2);
	tavolo = insert_in_list(tavolo, gamba3);
	tavolo = insert_in_list(tavolo, gamba4);

	/*** FOTO ***/
	foto = read_nurbs("foto.db");
	set_x_rotate(foto,90,1);
	set_translate(foto,-0.5,0,-0.1);
	set_projection_texture(foto, lucido_foto, "texture/foto.hr",1,1,0.4,0.9);
	set_x_rotate(foto,-90,1);
	set_scale(foto,0.6,0.6,1);
	set_z_rotate(foto, 120, 1);
	set_translate(foto,-0.3,-0.5,0);

	/*** CASCO ***/
	guscio = read_nurbs("casco.db");
	set_attribute(guscio,plastica_casco);
	visiera = read_nurbs("visiera.db");
	visiera_sx = read_nurbs("visiera_sx.db");
	visiera_dx = read_nurbs("visiera_dx.db");
	set_translate(visiera,0.01,0,0);
	set_translate(visiera_sx,0.01,0,0);
	set_translate(visiera_dx,0.01,0,0);
	set_attribute(visiera_sx,plastica_casco2);
	set_attribute(visiera_dx,plastica_casco2);
	set_attribute(visiera,cromatura2);
	casco = create_list (guscio, "Casco");
	casco = insert_in_list(casco,visiera);
	casco = insert_in_list(casco,visiera_sx);
	casco = insert_in_list(casco,visiera_dx);

	set_translate(casco,-1,1.2,-0.05);
	set_z_rotate(casco,-30,1);


	scene = create_list(garage, "scene");
	scene = insert_in_list(scene, moto);
	scene = insert_in_list(scene, casco);
	scene = insert_in_list(scene, tavolo);
	scene = insert_in_list(scene, foto);

	save_scene("monster_script.md","scene_monster",scene);
	return(0);
}
